
from types import *
import marshal

ftypes = [FunctionType,LambdaType,BuiltinFunctionType,BuiltinMethodType]

class TransportFunction:
   def FuncToDict(self,g,deps=[]):
     p = "code","dict","doc","closure","name"
     d = {}
     [d.__setitem__(k,getattr(g,"func_"+k)) for k in p]
     d["defaults"] = []
     d["dtypes"] = []
     if g.func_defaults:
        [d["dtypes"].append(v.__class__.__name__) for j,v in enumerate(g.func_defaults)]
        [d["defaults"].append((type(v) in ftypes and self.FuncToDict(v)) or v) \
              for j,v in enumerate(g.func_defaults)]
     d["deps"] = [self.FuncToDict(gd) for gd in deps]
     return d

   def SaveFunction(self,g,deps=[]):
      d=self.FuncToDict(g,deps=deps)
      f = open("%s.mpy" % (d["name"]),"w")
      print "Writing",f.name
      s = marshal.dump(d,f)
      f.close()

   def MarshalFunction(self,g,deps=[]):
      d=self.FuncToDict(g,deps=deps)
      s = marshal.dumps( d)
      return s

   def DictToFunc(self,s,globals):
      s["defaults"] = tuple([(t in ["function"] and self.DictToFunc(d,globals) or d) \
           for d,t in zip(s["defaults"], s["dtypes"])])
      [self.DictToFunc(sd,globals=globals) for sd in s["deps"]]
      g = FunctionType(s["code"],globals,s["name"],s["defaults"],s["closure"])
      return g

   def ReadFunction(self,g,globals):
      f = open(g,"r")
      s = marshal.load(f)
      f.close()
      print "Reading",s["name"]
      g = self.DictToFunc(s,globals)
      if s["name"] != "<lambda>": globals[s["name"]] = g
      return s["name"],g

   def UnmarshalFunction(self,d,globals):
      s = marshal.loads(d)
      g = self.DictToFunc(s,globals)
      if s["name"] != "<lambda>": globals[s["name"]] = g
      return s["name"],g

