
from FITS import *
from VTKHelperFunctions import *
from basics import *
from Mestimators import *

def LineFit(x,y,w):
#  y=a+b*x
#   print x.shape, y.shape, w.shape
   w2 = w**2
   x2 = x**2
   y2 = y**2
   xy = x*y
   S=sum(1*w2)
   Sx=sum(x*w2)
   Sy=sum(y*w2)
   Sxx=sum(x2*w2)
   Sxy=sum(xy*w2)
   d=S*Sxx-Sx**2
   a=divz(Sxx*Sy-Sx*Sxy,d)
   b=divz(S*Sxy-Sx*Sy,d)
   return asarray([a,b])

done = {}
def xOneRow(a):
    x = OneRow(a[0],a[1],a[2],a[3],a[4])
    done.setdefault(a[0])
    if len(done) and not (len(done)%16):
       sys.stdout.write(".")
       sys.stdout.flush()
    return x

def OneRow(j,G,Gm,exptime,nmodes):
    if isinstance(G[0],StringType):
#       print "Open",G
       F = [FITS(f) for f in G]
       if Gm: Fm = [FITS(f) for f in Gm]
       else: Fm = []
    else:
       F = G
       Fm = Gm
    naxis1 = F[0]["naxis1"]
    r = asarray([f.row(j) for f in F])/exptime[::,NewAxis]
    if len(Fm):
       rm = equal(asarray([f.row(j) for f in Fm]),0).astype(float32)
    else:
       rm = not_equal(r,0.0).astype(float32)
    print j,
    print 1.*sum(rm.ravel())/len(rm.ravel())
    if isinstance(G[0],StringType):
       [f.close() for f in F]
       [f.close() for f in Fm]
    nmodes = nmodes[::,NewAxis]*ones((len(nmodes),naxis1),float32)
    wrm = 1.*rm
    for j in range(5):
       sol = LineFit(nmodes,r,wrm)
#       b = polynom(nmodes,1)
#       left,right = transpose(b*rm[NewAxis,::,::]),transpose(r*rm)
#       sol = transpose([svdfit(left1,right1) for left1,right1 in zip(left,right)])
       fit = sol[0] + sol[1]*nmodes
       res = (r-fit)
       rms = getsqrt(divz(sum(power(res*wrm,2)),sum(wrm)))
       wrm = rm*Huber(divz(res,rms),w=1)
    return concatenate([sol,[rms]])


